/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : VECTREX HP3000 Analog CRT X,Y,Z & Compare Emulation Module */
/*                                                                           */
/*   File Name  : ANALOG.H                                                   */
/*                                                                           */
/*   Author     : Keith Wilkins / C.S.                                       */
/*                                                                           */
/*   Version    : 1.20                                                       */
/*                                                                           */
/*   Desciption : The file contains the definitions and function prototypes  */
/*                for the analog emulation module of the vectrex emulator    */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    13/03/93  K.W  Creation                                        */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*    1.20    20/10/96  C.S  DVE V1.20                                       */
/*                                                                           */
/*****************************************************************************/

#if !defined ANALOG_H
    #define ANALOG_H

/* defines & typedefs */

/* Function Prototypes */


extern void    (* fAnalogTick)(void);
void    fAnalogTick_linear_shift(void);
void    fAnalogTick_linear_div(void);
void    fAnalogTick_bank_shift(void);
void    fAnalogTick_bank_div(void);
void    fAnalogTick_linear_shift_lightpen(void);
void    fAnalogTick_linear_div_lightpen(void);
void    fAnalogTick_bank_shift_lightpen(void);
void    fAnalogTick_bank_div_lightpen(void);
void    fAnalogTick_linear_shift_imager(void);
void    fAnalogTick_linear_div_imager(void);
void    fAnalogTick_bank_shift_imager(void);
void    fAnalogTick_bank_div_imager(void);



BOOL    fAnalogInit(void);
void    fAnalogReset(void);
void    fAnalogJoystickUpdateAnalog(void);
void    fAnalogJoystickUpdateDigital(void);
extern void (* fAnalogJoystickUpdate)(void);

extern SBYTE      lXSampleHold; //SLONG
extern SBYTE      lYSampleHold; //SLONG
extern UBYTE      tZSampleHold;

extern SLONG      lSIGDEF_XOUTPUT;
extern SLONG      lSIGDEF_YOUTPUT;
extern UBYTE      tSIGDEF_ZOUTPUT;

extern SLONG      DAC_lookup[256];


extern ULONG   lwTickMark;
extern UBYTE   tLastRamp;

extern SLONG lX1,lY1;
extern UBYTE tOldBlank,tBright;

#ifdef DEBUG_MSG
extern SLONG lOldXSH,lOldYSH;
extern UBYTE tOldZSH;

extern SLONG lOldSigX,lOldSigY;
extern UBYTE tOldSigZ;

extern UBYTE tOldBlank;
extern UBYTE tOldRamp;
extern UBYTE tOldZero;
extern UBYTE tOldSel;
extern UBYTE tOldShold;

extern ULONG lwTickMark;
extern UBYTE tLastRamp;
extern SLONG lX1,lY1;
extern UBYTE tOldBlank,tBright;


#endif



#endif

/* End of ANALOG.H */



