/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : This file contains function prototypes for the 6809        */
/*                dissasembler module.                                       */
/*                                                                           */
/*   File Name  : DIS6809.H                                                  */
/*                                                                           */
/*   Author     : Keith Wilkins                                              */
/*                                                                           */
/*   Version    : 1.00                                                       */
/*                                                                           */
/*   Desciption : The 6809 disassembler function prototypes                  */
/*                and necessary definitions                                  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    11/04/94  K.W  Creation                                        */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*                                                                           */
/*****************************************************************************/

#if !defined DIS6809_H
    #define DIS6809_H

/* Defines for this module */

#define ILLEGAL		0
#define PAGE2		    1
#define PAGE3		    2
#define DIRECT		    3
#define EXTENDED	    4
#define INHERENT	    5
#define RELATIVE8	    6
#define RELATIVE16	    7
#define IMMEDIATE8	    8
#define IMMEDIATE16	9
#define INDEXED		10
#define REGISTER1	    11
#define REGISTER2	    12

typedef struct sMNEMONIC
{
	UBYTE   acInstruction[6];
	UBYTE   bAddressMode;
	
}tsMNEMONIC,*ptsMNEMONIC;


/* Function prototypes */         
UWORD  f6809Disassemble(UWORD,UBYTE*);
UBYTE  f6809CycleCount(UWORD wAddr);

extern tsMNEMONIC as6809Dis[];
extern UBYTE  ac6809Modes[][20];


#endif

/* End of dis6809.h */
