/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : Vectrex Emulator Text Font Definition File                 */
/*                                                                           */
/*   File Name  : FONT.H                                                     */
/*                                                                           */
/*   Author     : Keith Wilkins                                              */
/*                                                                           */
/*   Version    : 1.00                                                       */
/*                                                                           */
/*   Desciption : This file contains the array that defines the character    */
/*                map for all of the vectrex character set.                  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    12/04/94  K.W  Creation                                        */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*                                                                           */
/*****************************************************************************/

#ifndef FONT_H
   #define FONT_H


UBYTE   atFontDef[128][BASE_FONT_HEIGHT]=
{ 
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,           /* 0x00 -   */
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,

   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,           /* 0x08 -   */
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,

   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,           /* 0x10 -   */
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,

   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,           /* 0x18 -   */
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,
   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,

   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,           /* 0x20 -   */
   0x08,0x08,0x08,0x08,0x08,0x00,0x08,0x00,                  /* ! */
   0x14,0x14,0x00,0x00,0x00,0x00,0x00,0x00,                  /* " */
   0x14,0x14,0x3e,0x14,0x3e,0x14,0x14,0x00,                  /* # */
   0x08,0x1c,0x28,0x1c,0x0a,0x1c,0x08,0x00,                  /* $ */
   0x22,0x04,0x04,0x08,0x10,0x10,0x22,0x00,                  /* % */
   0x18,0x24,0x24,0x18,0x24,0x24,0x1a,0x00,                  /* & */
   0x04,0x08,0x00,0x00,0x00,0x00,0x00,0x00,                  /* ' */

   0x04,0x08,0x08,0x08,0x08,0x08,0x04,0x00,           /* 0x28 - ( */
   0x10,0x08,0x08,0x08,0x08,0x08,0x10,0x00,                  /* ) */
   0x00,0x22,0x1c,0x3e,0x1c,0x22,0x00,0x00,                  /* * */
   0x00,0x08,0x08,0x3e,0x08,0x08,0x00,0x00,                  /* + */
   0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x10,                  /* , */
   0x00,0x00,0x00,0x3e,0x00,0x00,0x00,0x00,                  /* - */
   0x00,0x00,0x00,0x00,0x00,0x00,0x08,0x00,                  /* . */
   0x00,0x02,0x04,0x08,0x10,0x20,0x00,0x00,                  /* / */

   0x1c,0x22,0x26,0x2a,0x32,0x22,0x1c,0x00,           /* 0x30 - 0 */
   0x08,0x18,0x08,0x08,0x08,0x08,0x1c,0x00,                  /* 1 */
   0x1c,0x22,0x04,0x08,0x10,0x20,0x3e,0x00,                  /* 2 */
   0x1c,0x22,0x02,0x1c,0x02,0x22,0x1c,0x00,                  /* 3 */
   0x04,0x0c,0x14,0x24,0x3e,0x04,0x04,0x00,                  /* 4 */
   0x3e,0x20,0x20,0x3c,0x02,0x02,0x3c,0x00,                  /* 5 */
   0x1c,0x22,0x20,0x3c,0x22,0x22,0x1c,0x00,                  /* 6 */
   0x3e,0x02,0x04,0x08,0x10,0x10,0x10,0x00,                  /* 7 */

   0x1c,0x22,0x22,0x1c,0x22,0x22,0x1c,0x00,           /* 0x38 - 8 */
   0x1c,0x22,0x22,0x1e,0x02,0x22,0x1c,0x00,                  /* 9 */
   0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x00,                  /* : */
   0x00,0x00,0x00,0x00,0x08,0x00,0x08,0x10,                  /* ; */
   0x00,0x04,0x08,0x10,0x08,0x04,0x00,0x00,                  /* < */
   0x00,0x00,0x1c,0x00,0x1c,0x00,0x00,0x00,                  /* = */
   0x00,0x10,0x08,0x04,0x08,0x10,0x00,0x00,                  /* > */
   0x1c,0x22,0x04,0x08,0x08,0x00,0x08,0x00,                  /* ? */

   0xaa,0x54,0xaa,0x54,0xaa,0x54,0xaa,0x00,           /* 0x40 -   */
   0x1c,0x22,0x22,0x3e,0x22,0x22,0x22,0x00,                  /* A */
   0x3c,0x22,0x22,0x3c,0x22,0x22,0x3c,0x00,                  /* B */
   0x1e,0x20,0x20,0x20,0x20,0x20,0x1e,0x00,                  /* C */
   0x3c,0x22,0x22,0x22,0x22,0x22,0x3c,0x00,                  /* D */
   0x3e,0x20,0x20,0x38,0x20,0x20,0x3e,0x00,                  /* E */
   0x3e,0x20,0x20,0x38,0x20,0x20,0x20,0x00,                  /* F */
   0x1c,0x20,0x20,0x2e,0x22,0x22,0x1c,0x00,                  /* G */

   0x22,0x22,0x22,0x3e,0x22,0x22,0x22,0x00,           /* 0x48 - H */
   0x3e,0x08,0x08,0x08,0x08,0x08,0x3e,0x00,                  /* I */
   0x3e,0x08,0x08,0x08,0x08,0x28,0x10,0x00,                  /* J */
   0x22,0x24,0x28,0x30,0x28,0x24,0x22,0x00,                  /* K */
   0x20,0x20,0x20,0x20,0x20,0x20,0x3e,0x00,                  /* L */
   0x22,0x36,0x2a,0x22,0x22,0x22,0x22,0x00,                  /* M */
   0x32,0x32,0x2a,0x2a,0x2a,0x26,0x26,0x00,                  /* N */
   0x1c,0x22,0x22,0x22,0x22,0x22,0x1c,0x00,                  /* O */

   0x3c,0x22,0x22,0x3c,0x20,0x20,0x20,0x00,           /* 0x50 - P */
   0x1c,0x22,0x22,0x22,0x22,0x22,0x1c,0x02,                  /* Q */
   0x3c,0x22,0x22,0x3c,0x24,0x22,0x22,0x00,                  /* R */
   0x1e,0x20,0x20,0x1c,0x02,0x02,0x3c,0x00,                  /* S */
   0x3e,0x08,0x08,0x08,0x08,0x08,0x08,0x00,                  /* T */
   0x22,0x22,0x22,0x22,0x22,0x22,0x1c,0x00,                  /* U */
   0x22,0x22,0x22,0x22,0x14,0x14,0x08,0x00,                  /* V */
   0x22,0x22,0x22,0x22,0x2a,0x36,0x22,0x00,                  /* W */

   0x22,0x22,0x14,0x08,0x14,0x22,0x22,0x00,           /* 0x58 - X */
   0x22,0x22,0x14,0x08,0x08,0x08,0x08,0x00,                  /* Y */
   0x3e,0x02,0x04,0x08,0x10,0x20,0x3e,0x00,                  /* Z */
   0x0c,0x08,0x08,0x08,0x08,0x08,0x0c,0x00,                  /* [ */
   0x00,0x20,0x10,0x08,0x04,0x02,0x00,0x00,                  /* \ */
   0x18,0x08,0x08,0x08,0x08,0x08,0x18,0x00,                  /* ] */
   0x08,0x14,0x00,0x00,0x00,0x00,0x00,0x00,                  /* ^ */
   0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x3e,                  /* _ */

   0x08,0x04,0x00,0x00,0x00,0x00,0x00,0x00,           /* 0x60 - ` */
   0x00,0x00,0x1c,0x22,0x22,0x22,0x1f,0x00,                  /* a */
   0x20,0x20,0x3c,0x22,0x22,0x22,0x3c,0x00,                  /* b */
   0x00,0x00,0x1e,0x20,0x20,0x20,0x1e,0x00,                  /* c */
   0x02,0x02,0x1e,0x22,0x22,0x22,0x1e,0x00,                  /* d */
   0x00,0x00,0x1c,0x22,0x3e,0x20,0x1e,0x00,                  /* e */
   0x06,0x08,0x08,0x3e,0x08,0x08,0x08,0x00,                  /* f */
   0x00,0x00,0x1e,0x22,0x22,0x1e,0x02,0x1e,                  /* g */

   0x20,0x20,0x3c,0x22,0x22,0x22,0x22,0x00,           /* 0x68 - h */
   0x08,0x00,0x18,0x08,0x08,0x08,0x1c,0x00,                  /* i */
   0x04,0x00,0x04,0x04,0x04,0x24,0x18,0x00,                  /* j */
   0x20,0x24,0x28,0x30,0x28,0x24,0x22,0x00,                  /* k */
   0x08,0x08,0x08,0x08,0x08,0x08,0x04,0x00,                  /* l */
   0x00,0x00,0x36,0x2a,0x22,0x22,0x22,0x00,                  /* m */
   0x00,0x00,0x2c,0x32,0x22,0x22,0x22,0x00,                  /* n */
   0x00,0x00,0x1c,0x22,0x22,0x22,0x1c,0x00,                  /* o */

   0x00,0x00,0x3c,0x22,0x22,0x22,0x3c,0x20,           /* 0x70 - p */
   0x00,0x00,0x1e,0x22,0x22,0x22,0x1e,0x02,                  /* q */
   0x00,0x00,0x2c,0x32,0x20,0x20,0x20,0x00,                  /* r */
   0x00,0x00,0x1e,0x20,0x1c,0x02,0x3c,0x00,                  /* s */
   0x00,0x08,0x3e,0x08,0x08,0x0a,0x04,0x00,                  /* t */
   0x00,0x00,0x22,0x22,0x22,0x22,0x1c,0x00,                  /* u */
   0x00,0x00,0x22,0x22,0x22,0x14,0x08,0x00,                  /* v */
   0x00,0x00,0x22,0x22,0x22,0x2a,0x36,0x00,                  /* w */

   0x00,0x00,0x22,0x14,0x08,0x14,0x22,0x00,           /* 0x78 - x */
   0x00,0x00,0x22,0x22,0x22,0x1e,0x02,0x1c,                  /* y */
   0x00,0x00,0x3e,0x04,0x08,0x10,0x3e,0x00,                  /* z */
   0x0c,0x08,0x08,0x10,0x08,0x08,0x0c,0x00,                  /* { */
   0x08,0x08,0x08,0x00,0x08,0x08,0x08,0x08,                  /* | */
   0x18,0x08,0x08,0x04,0x08,0x08,0x18,0x00,                  /* } */
   0x14,0x28,0x00,0x00,0x00,0x00,0x00,0x00,                  /* ~ */
   0x00,0x00,0x08,0x14,0x22,0x22,0x3e,0x00,                  /*   */
};


#endif



/* End of FONT.H */
