/*****************************************************************************/
/*                                                                           */
/*   KEYBBOARD Library                             Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : Keyabord input functions header file                       */
/*                                                                           */
/*   File Name  : KEYBOARD.H                                                 */
/*                                                                           */
/*   Author     : Keith Wilkins                                              */
/*                                                                           */
/*   Version    : 1.00                                                       */
/*                                                                           */
/*   Desciption : This file contains the function prototypes and definitions */
/*                for the keyabord handler subsystem                         */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    20/03/93  K.W  Creation                                        */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*                                                                           */
/*****************************************************************************/

#if !defined KEYBOARD_H
    #define KEYBOARD_H


#include "keydef.h"
#include "scandef.h"

// Define function prototypes


//
// All of thes functions are based in KEY_x (keydef.h)
//   (Under no circumstances use the scan codes)
//

BOOL     fKBDinit(void);
BOOL     fKBDrestore(void);
void     fKBDbuffering(BOOL bState);
UWORD    fKBDgetch(void);
void     fKBDungetch(UWORD tKeypress);
BOOL     fKBDhit(void);
BOOL     fKBDfuncreg(UWORD tKeyNum,void (*pfKeyFunc)(UWORD));
void     fKBDnotused(UWORD tKeyVal);
void     fKBDdokey(void);
void     fKBDbufferenable(BOOL bState);


//
// This function is based in SCAN_x (scandef.h)
//

BOOL     fKBDisdown(UWORD iScancode);


#ifdef KEYBOARD_C
 BOOL           bKBDKeyPressed=FALSE;
#else
 extern BOOL    bKBDKeyPressed;
#endif

#endif

/* End of KEYBOARD.H */



