/*****************************************************************************/
/*                                                                           */
/*   Function    : fIODrawMaskLine()                                         */
/*                                                                           */
/*   Author      : K.W / C.S.                                                */
/*                                                                           */
/*   Description : Draws a line on the screen clipped to the screen boundary */
/*                 and in the given colour BUT ALL screen writes are OR'd    */
/*                 with the overlay memory BEFORE being written.             */
/*                                                                           */
/*   Accepts     : PIXELs given start and end position of line and colour    */
/*                                                                           */
/*   Returns     : nothing                                                   */
/*                                                                           */
/*****************************************************************************/
/* Optimization can be done here still, look at io.c for some ideas */
/********************************************************************/

//void fIODrawMaskLinebank(SWORD iX1,SWORD iY1,SWORD iX2,SWORD iY2,SWORD iColour)
{
 SWORD   dx=0,dy=0,err=0,inc=0;

#ifdef DISPLAY_TICK_IMAGER
 if (ImagerColorNow ==IMAGER_DRAW_OVERLAY)
 {
  /**************************/
  /* Do straight line cases */
  /**************************/
  if(iX1==iX2)
  {
   if(iY1>iY2)
   {
    fSwap(&iY1,&iY2);
   }
   do
   {
    /******************************************************************************************/
    /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
    /******************************************************************************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
    }
   }
   while(iY1++!=iY2);
  }
  else if(iY1==iY2)
  {
   if(iX1>iX2)
   {
    fSwap(&iX1,&iX2);
   }
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   do
   {
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
    }
    offset++;
   }
   while(iX1++!=iX2);
  }
  else
  {
   /* X Variant */
   dx=iX2-iX1;
   dy=iY2-iY1;

   if(abs(dx)>=abs(dy))
   {
    if(iX1>iX2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }

    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dx>>1);

    if(dy>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dy=-dy;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     if (!(*(clip_memory+offset)))
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dy;
     if (err>0)
     {
      err-=dx;
      iY1+=inc;
     }
    }
    while(iX1++!=iX2);
   }
   else
   {
    if (iY1>iY2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }
    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dy>>1);
    if(dx>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dx=-dx;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     if (!(*(clip_memory+offset)))
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dx;

     if (err>=0)
     {
      err-=dy;
      iX1+=inc;
     }
    }
    while(iY1++!=iY2);
   }
  }
 } // if (ImagerColorNow ==IMAGER_DRAW_OVERLAY)
 else if (ImagerColorNow ==IMAGER_DRAW_NOTHING)
 {;}
 else
 {
  if (wGblImagerMode==6)
  {
   /**************************/
   /* Do straight line cases */
   /**************************/
   if(iX1==iX2)
   {
    if(iY1>iY2)
    {
     fSwap(&iY1,&iY2);
    }
   do
   {
    /******************************************************************************************/
    /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
    /******************************************************************************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
    }
   }
   while(iY1++!=iY2);
  }
  else if(iY1==iY2)
  {
   if(iX1>iX2)
   {
    fSwap(&iX1,&iX2);
   }
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   do
   {
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
    }
    offset++;
   }
   while(iX1++!=iX2);
  }
  else
  {
   /* X Variant */
   dx=iX2-iX1;
   dy=iY2-iY1;

   if(abs(dx)>=abs(dy))
   {
    if(iX1>iX2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }

    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dx>>1);

    if(dy>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dy=-dy;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dy;
     if (err>0)
     {
      err-=dx;
      iY1+=inc;
     }
    }
    while(iX1++!=iX2);
   }
   else
   {
    if (iY1>iY2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }
    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dy>>1);
    if(dx>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dx=-dx;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dx;

     if (err>=0)
     {
      err-=dy;
      iX1+=inc;
     }
    }
    while(iY1++!=iY2);
   }
  }

  //**
  }//(wGblImagerMode==6)
  else
  {
   /**************************/
   /* Do straight line cases */
   /**************************/
   if(iX1==iX2)
   {
    if(iY1>iY2)
    {
     fSwap(&iY1,&iY2);
    }
   do
   {
    /******************************************************************************************/
    /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
    /******************************************************************************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
    }
   }
   while(iY1++!=iY2);
  }
  else if(iY1==iY2)
  {
   if(iX1>iX2)
   {
    fSwap(&iX1,&iX2);
   }
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   do
   {
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
    }
    offset++;
   }
   while(iX1++!=iX2);
  }
  else
  {
   /* X Variant */
   dx=iX2-iX1;
   dy=iY2-iY1;

   if(abs(dx)>=abs(dy))
   {
    if(iX1>iX2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }

    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dx>>1);

    if(dy>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dy=-dy;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     if (!(*(clip_memory+offset)))
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dy;
     if (err>0)
     {
      err-=dx;
      iY1+=inc;
     }
    }
    while(iX1++!=iX2);
   }
   else
   {
    if (iY1>iY2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }
    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dy>>1);
    if(dx>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dx=-dx;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     if (!(*(clip_memory+offset)))
     {
      offset_x=(UWORD)(offset&vesa_and_x);
      if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
      {
       vesa_address_of_window[vesa_write_window]=new_win_address;
       vesa_set_write_window();
      }
      *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour  | ImagerColorNow;
     }
     /**********************/
     /* Check error status */
     /**********************/
     err+=dx;

     if (err>=0)
     {
      err-=dy;
      iX1+=inc;
     }
    }
    while(iY1++!=iY2);
   }
  }
  }//(wGblImagerMode==6)

 } // else if (ImagerColorNow ==IMAGER_DRAW_NOTHING)
#else
 /**************************/
 /* Do straight line cases */
 /**************************/
 if(iX1==iX2)
 {
  if(iY1>iY2)
  {
   fSwap(&iY1,&iY2);
  }
  do
  {
   /******************************************************************************************/
   /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
   /******************************************************************************************/
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   if (!(*(clip_memory+offset)))
   {
    offset_x=(UWORD)(offset&vesa_and_x);
    if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
    {
     vesa_address_of_window[vesa_write_window]=new_win_address;
     vesa_set_write_window();
    }
    *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
   }
  }
  while(iY1++!=iY2);
 }
 else if(iY1==iY2)
 {
  if(iX1>iX2)
  {
   fSwap(&iX1,&iX2);
  }
  offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
  do
  {
   if (!(*(clip_memory+offset)))
   {
    offset_x=(UWORD)(offset&vesa_and_x);
    if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
    {
     vesa_address_of_window[vesa_write_window]=new_win_address;
     vesa_set_write_window();
    }
    *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
   }
   offset++;
  }
  while(iX1++!=iX2);
 }
 else
 {
  /* X Variant */
  dx=iX2-iX1;
  dy=iY2-iY1;

  if(abs(dx)>=abs(dy))
  {
   if(iX1>iX2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }

   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dx>>1);

   if(dy>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dy=-dy;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dy;
    if (err>0)
    {
     err-=dx;
     iY1+=inc;
    }
   }
   while(iX1++!=iX2);
  }
  else
  {
   if (iY1>iY2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dy>>1);
   if(dx>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dx=-dx;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     offset_x=(UWORD)(offset&vesa_and_x);
     if (vesa_address_of_window[vesa_write_window]!=(new_win_address=(UWORD)(offset>>vesa_granularity_potenz)))
     {
      vesa_address_of_window[vesa_write_window]=new_win_address;
      vesa_set_write_window();
     }
     *((UBYTE *)(vesa_write_seg+offset_x))=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dx;

    if (err>=0)
    {
     err-=dy;
     iX1+=inc;
    }
   }
   while(iY1++!=iY2);
  }
 }
#endif
}
