/*****************************************************************************/
/*                                                                           */
/*   Function    : fIODrawMaskLine()                                         */
/*                                                                           */
/*   Author      : K.W / C.S.                                                */
/*                                                                           */
/*   Description : Draws a line on the screen clipped to the screen boundary */
/*                 and in the given colour BUT ALL screen writes are OR'd    */
/*                 with the overlay memory BEFORE being written.             */
/*                                                                           */
/*   Accepts     : PIXELs given start and end position of line and colour    */
/*                                                                           */
/*   Returns     : nothing                                                   */
/*                                                                           */
/*****************************************************************************/
//void fIODrawMaskLinelin(SWORD iX1,SWORD iY1,SWORD iX2,SWORD iY2,SWORD iColour)
{
 SWORD   dx=0,dy=0,err=0,inc=0;
 UBYTE   *dest=(UBYTE*)svdc->videoMem;

#ifdef DISPLAY_TICK_IMAGER

 if (ImagerColorNow ==IMAGER_DRAW_OVERLAY)
 {
 /**************************/
 /* Do straight line cases */
 /**************************/
 if(iX1==iX2)
 {
  if(iY1>iY2)
  {
   fSwap(&iY1,&iY2);
  }
  do
  {
   /******************************************************************************************/
   /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
   /******************************************************************************************/
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
   }
  }
  while(iY1++!=iY2);
 }
 else if (iY1==iY2)
 {
  if (iX1>iX2)
  {
   fSwap(&iX1,&iX2);
  }
  offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
  do
  {
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
   }
   offset++;
  }
  while(iX1++!=iX2);
 }
 else
 {
  /*************/
  /* X Variant */
  /*************/
  dx=iX2-iX1;
  dy=iY2-iY1;

  if (abs(dx)>=abs(dy))
  {
   if (iX1>iX2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dx>>1);
   if (dy>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dy=-dy;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dy;
    if(err>0)
    {
     err-=dx;
     iY1+=inc;
    }
   }
   while(iX1++!=iX2);
  }
  else
  {
   if(iY1>iY2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dy>>1);
   if (dx>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dx=-dx;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dx;

    if (err>=0)
    {
     err-=dy;
     iX1+=inc;
    }
   }
   while(iY1++!=iY2);
  }
 }

 }
 else if (ImagerColorNow ==IMAGER_DRAW_NOTHING)
 {;}
 else
 {
  if (wGblImagerMode==6)
  {
  /**************************/
  /* Do straight line cases */
  /**************************/
  if(iX1==iX2)
  {
   if(iY1>iY2)
   {
    fSwap(&iY1,&iY2);
   }
   do
   {
    /******************************************************************************************/
    /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
    /******************************************************************************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
   }
   while(iY1++!=iY2);
  }
  else if (iY1==iY2)
  {
   if (iX1>iX2)
   {
    fSwap(&iX1,&iX2);
   }
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   do
   {
    *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
    offset++;
   }
   while(iX1++!=iX2);
  }
  else
  {
   /*************/
   /* X Variant */
   /*************/
   dx=iX2-iX1;
   dy=iY2-iY1;
   if (abs(dx)>=abs(dy))
   {
    if (iX1>iX2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }
    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dx>>1);
    if (dy>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dy=-dy;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
     /**********************/
     /* Check error status */
     /**********************/
     err+=dy;
     if(err>0)
     {
      err-=dx;
      iY1+=inc;
     }
    }
    while(iX1++!=iX2);
   }
   else
   {
    if(iY1>iY2)
    {
     fSwap(&iX1,&iX2);
     fSwap(&iY1,&iY2);
    }
    dx=iX2-iX1;
    dy=iY2-iY1;

    err=-(dy>>1);
    if (dx>0)
    {
     inc=1;
    }
    else
    {
     inc=-1;
     dx=-dx;
    }
    do
    {
     /**************************/
     /* Calulate byte position */
     /**************************/
     offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
     *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
     /**********************/
     /* Check error status */
     /**********************/
     err+=dx;

     if (err>=0)
     {
      err-=dy;
      iX1+=inc;
     }
    }
    while(iY1++!=iY2);
   }
  }
 } //(wGblImagerMode==6)
 else
 {
 /**************************/
 /* Do straight line cases */
 /**************************/
 if(iX1==iX2)
 {
  if(iY1>iY2)
  {
   fSwap(&iY1,&iY2);
  }
  do
  {
   /******************************************************************************************/
   /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
   /******************************************************************************************/
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
   }
  }
  while(iY1++!=iY2);
 }
 else if (iY1==iY2)
 {
  if (iX1>iX2)
  {
   fSwap(&iX1,&iX2);
  }
  offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
  do
  {
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
   }
   offset++;
  }
  while(iX1++!=iX2);
 }
 else
 {
  /*************/
  /* X Variant */
  /*************/
  dx=iX2-iX1;
  dy=iY2-iY1;

  if (abs(dx)>=abs(dy))
  {
   if (iX1>iX2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dx>>1);
   if (dy>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dy=-dy;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dy;
    if(err>0)
    {
     err-=dx;
     iY1+=inc;
    }
   }
   while(iX1++!=iX2);
  }
  else
  {
   if(iY1>iY2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dy>>1);
   if (dx>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dx=-dx;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | ImagerColorNow;;
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dx;

    if (err>=0)
    {
     err-=dy;
     iX1+=inc;
    }
   }
   while(iY1++!=iY2);
  }
 }

 }
 } //(wGblImagerMode==6)


#else
 /**************************/
 /* Do straight line cases */
 /**************************/
 if(iX1==iX2)
 {
  if(iY1>iY2)
  {
   fSwap(&iY1,&iY2);
  }
  do
  {
   /******************************************************************************************/
   /* not to be put out of loop, offset can get to high... (high iY1 are pointing to maxline)*/
   /******************************************************************************************/
   offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
   }
  }
  while(iY1++!=iY2);
 }
 else if (iY1==iY2)
 {
  if (iX1>iX2)
  {
   fSwap(&iX1,&iX2);
  }
  offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
  do
  {
   if (!(*(clip_memory+offset)))
   {
    *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
   }
   offset++;
  }
  while(iX1++!=iX2);
 }
 else
 {
  /*************/
  /* X Variant */
  /*************/
  dx=iX2-iX1;
  dy=iY2-iY1;

  if (abs(dx)>=abs(dy))
  {
   if (iX1>iX2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dx>>1);
   if (dy>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dy=-dy;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dy;
    if(err>0)
    {
     err-=dx;
     iY1+=inc;
    }
   }
   while(iX1++!=iX2);
  }
  else
  {
   if(iY1>iY2)
   {
    fSwap(&iX1,&iX2);
    fSwap(&iY1,&iY2);
   }
   dx=iX2-iX1;
   dy=iY2-iY1;

   err=-(dy>>1);
   if (dx>0)
   {
    inc=1;
   }
   else
   {
    inc=-1;
    dx=-dx;
   }
   do
   {
    /**************************/
    /* Calulate byte position */
    /**************************/
    offset=linestartpos[(UWORD)iY1]+(ULONG)iX1;
    if (!(*(clip_memory+offset)))
    {
     *(dest+offset)=(UBYTE)iColour | *(overlay_memory+offset);
    }
    /**********************/
    /* Check error status */
    /**********************/
    err+=dx;

    if (err>=0)
    {
     err-=dy;
     iX1+=inc;
    }
   }
   while(iY1++!=iY2);
  }
 }
#endif
}
