/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : Vectrex emulator sequencing module header file             */
/*                                                                           */
/*   File Name  : SEQUENCE.H                                                 */
/*                                                                           */
/*   Author     : Keith Wilkins / C.S.                                       */
/*                                                                           */
/*   Version    : 1.20                                                       */
/*                                                                           */
/*   Desciption : This file contains the functions definitions & prototypes  */
/*                for the sequencer module.                                  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    14/03/93  K.W  Creation of empty file and descriptions         */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*    1.00    20/10/96  C.S  DVE V1.20                                       */
/*                                                                           */
/*****************************************************************************/

#if !defined SEQUENCE_H
    #define SEQUENCE_H



#define DOS_TIMER_IRQ  0x1c

/**********************************/
/* Define any function prototypes */
/**********************************/

/***************************/
/* The main emulation loop */
/***************************/
extern BOOL (* fVectrexEmulate)(void);

extern int state;


#ifdef CLAY_ONLY
extern int cgrabsdone;
#endif

BOOL fVectrexEmulate_linear_no_lightpen(void);
BOOL fVectrexEmulate_banked_no_lightpen(void);
BOOL fVectrexEmulate_linear_lightpen(void);
BOOL fVectrexEmulate_banked_lightpen(void);
BOOL fVectrexEmulate_linear_imager(void);
BOOL fVectrexEmulate_banked_imager(void);

BOOL fTimerInit(void);
BOOL fTimerRestore(void);

#endif
/* End of SEQUENCE.H */



