/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : AY-3-8192 Sound Chip emulation module header file          */
/*                                                                           */
/*   File Name  : SOUNDEMU.H                                                 */
/*                                                                           */
/*   Author     : Keith Wilkins                                              */
/*                                                                           */
/*   Version    : 1.00                                                       */
/*                                                                           */
/*   Desciption : This file contains the function prototypes and definitions */
/*                for the AY-3-8192 sound chip emulation module.             */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    14/03/93  K.W  Creation of empty file and descriptions         */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*                                                                           */
/*****************************************************************************/

#if !defined SOUNDEMU_H
    #define SOUNDEMU_H

#include "vectrex.h"

/* Function prototypes */
void fplaysample(char *acGblDefaultCartFileName);

BOOL fSoundInit(void);
void fSoundReset(void);
void fSoundRestore(void);
void fSoundTick(void);

void fSoundMute(void);
void fSoundResume(void);

extern UBYTE tOLD_BC1;
extern UBYTE tOLD_BDIR;
extern UWORD tAddr;

//extern  short digisound=false;


#endif

/* End of SOUNDEMU.H */



