
/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : Vectrex emulator debugging functions header file           */
/*                                                                           */
/*   File Name  : VDEBUG.H                                                   */
/*                                                                           */
/*   Author     : Keith Wilkins                                              */
/*                                                                           */
/*   Version    : 1.00                                                       */
/*                                                                           */
/*   Desciption : This file contains header file information for the         */
/*                vectrex debugging functions.                               */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    15/03/93  K.W  Creation of empty file and descriptions         */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*                                                                           */
/*****************************************************************************/

#if !defined VDEBUG_H
  #define VDEBUG_H
   
/* Defines for debug */

#define VERROR   3
#define HIGH    2
#define MED     1
#define MID     1
#define LOW     0
#ifdef DEBUG_MSG



// Define window information structure

typedef struct debugwininfo
{
   SWORD iWinXpos;
   SWORD iWinYpos;
   SWORD iWinXsize;
   SWORD iWinYsize;
   SWORD iWinFGcolour;
   SWORD iWinBGcolour;
   SWORD iWinBDcolour;
   SWORD iWinFontsize;
   SWORD iTitleFGcolour;
   SWORD iTitleBGcolour;
}DEBUGWININFO;


/* Define function prototyoes */

BOOL       fDebugInit(void);

#ifdef DEBUG_MON
  void     fDebugMonitorToggle(UWORD tKeyPress);
#endif

//#ifdef DEBUG_MSG
  #define  fDebug(level,body) ((bGblDebugEnable==TRUE && level>=tGblDebugLevel)?(tGblDebugMsgLevel=level),(fDebugXX body):0)
  SWORD    fDebugXX(UBYTE *pcDebugString,...);
  void     fDebugToggle(UWORD tKeyPress);
  void     fDebugFileToggle(UWORD tKeyPress);
  void     fDebugLevelLow(UWORD tKeyPress);
  void     fDebugLevelMid(UWORD tKeyPress);
  void     fDebugLevelHigh(UWORD tKeyPress);
#else
  #define  fDebug(level,body) ((void)0)
#endif


#endif


/* End of VDEBUG.H */



