

/* Initialisierung Modul globaler Daten */
volatile int vesa_mouse_interrupt=0;
int vesa_mouse_verstecke=0;
int vesa_mouse_x_old=0;
int vesa_mouse_y_old=0;
int vesa_mouse_jetzt_hg_schreiben=FALSE;
int vesa_mouse_jetzt_hg_sichern=TRUE;
int vesa_mouse_jetzt_schreiben=FALSE;
BYTE vesa_mouse_outline=2;
BYTE vesa_mouse_fill=1;
BYTE vesa_mouse_back=0;
BYTE *vesa_mouse_zeiger_rettung=NULL;

/* Initialisierung globaler Daten */
MOUSE_POINTER vesa_mouse_zeiger={MAUS_GROESSE_X_DEFAULT,MAUS_GROESSE_Y_DEFAULT,vesa_mauszeiger_default};
int vesa_mouse_initialisiert=FALSE;
volatile int vesa_mouse_x=0;
volatile int vesa_mouse_y=0;
volatile int vesa_mouse_button=0;

void vesa_initialisiere_modus_daten(void);
void vesa_clear_modus_daten(void);
void vesa_mouse_update(void);
void vesa_mouse_force_update(void);
void vesa_mouse_hintergrund_sichern(void);
void vesa_mouse_hintergrund_schreiben(void);
void vesa_mouse_schreiben(void);

int vesa_mouse_get_irq(void)
{
        union REGS regs;
        struct SREGS sregs;
        regs.x.ax=0x24;
        int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
        if (regs.x.ax==(unsigned int)-1)
                return 0;
        return regs.h.cl;
}

/***************************************************************/

#pragma option -N- -k-

void __interrupt vesa_mouse_update(void)
{
/*
        asm {
                pushf
                pusha
                mov bp,SEG(vesa_mouse_interrupt)
                mov ds,bp
                mov vesa_mouse_x,cx
                mov vesa_mouse_y,dx
                mov vesa_mouse_button,bx
        }
        if (vesa_mouse_interrupt==0)
        {
                vesa_mouse_interrupt++;
//              vesa_set_dac_register(0,0,255,0);
                if (vesa_mouse_jetzt_hg_schreiben==TRUE)
                {
                        vesa_mouse_hintergrund_schreiben();
                }
                if (vesa_mouse_jetzt_hg_sichern==TRUE)
                {
                        vesa_mouse_hintergrund_sichern();
                        vesa_mouse_jetzt_hg_schreiben=TRUE;
                }
                if (vesa_mouse_jetzt_schreiben==TRUE)
                {
                        vesa_mouse_schreiben();
                }
//              vesa_set_dac_register(0,0,0,0);
                vesa_mouse_interrupt--;
        }
        asm {
                popa
                popf
        }
*/
}

/***************************************************************/

void vesa_mouse_force_update(void)
{
        vesa_mouse_interrupt++;
        if (vesa_mouse_jetzt_hg_schreiben==TRUE)
                vesa_mouse_hintergrund_schreiben();
        if (vesa_mouse_jetzt_hg_sichern==TRUE)
        {
                vesa_mouse_hintergrund_sichern();
                vesa_mouse_jetzt_hg_schreiben=TRUE;
        }
        if (vesa_mouse_jetzt_schreiben==TRUE)
                vesa_mouse_schreiben();
        vesa_mouse_interrupt--;
}

/***************************************************************/

void vesa_mouse_hintergrund_sichern(void)
{
static  int i;
static  int p;
static  int neue_seg_adresse;
static  long offset;
static  BYTE *zeiger_auf_pointer;
static  WORD offset_x;
static  WORD zeilen_laenge;

 zeilen_laenge=vesa_mouse_zeiger.groesse_x;
        for (p=0;p<vesa_mouse_zeiger.groesse_y;p++)
        {
                zeiger_auf_pointer=vesa_mouse_zeiger_rettung+p*vesa_mouse_zeiger.groesse_x;
                offset=vesa_mouse_x+(long)(vesa_mouse_y+p)*vesa_aufloesung_x;
                offset_x=(int)(offset&vesa_and_x);      /* x-koordinate */
                if (vesa_fenster_adresse[vesa_lese_fenster]!=(neue_seg_adresse=(int)(offset>>vesa_granularitaet_potenz)))
                {
                        vesa_fenster_adresse[vesa_lese_fenster]=neue_seg_adresse;
                        setze_neues_lese_vesa_fenster();
                }
  for (i=0;i<zeilen_laenge;i++)
  {
                        _AX=vesa_segment_adresse_fenster[vesa_lese_fenster];
                        _BX=(int) offset_x;
                        asm {
                                push ax
                                pop      es
                                mov      cl,es:[bx]
                        }
                        zeiger_auf_pointer[i]=_CL;
                        offset_x++;
                        if (offset_x==vesa_offset_compare)
                        {
                                offset_x=0;
                                vesa_fenster_adresse[vesa_lese_fenster]++;
                                setze_neues_lese_vesa_fenster();
                        }
                }
        }
}

/***************************************************************/

void vesa_mouse_hintergrund_schreiben(void)
{
static  int i;
static  int p;
static  int neue_seg_adresse;
static  long offset;
static  BYTE *zeiger_auf_pointer;
static  WORD offset_x;
static  WORD zeilen_laenge;
zeilen_laenge=vesa_mouse_zeiger.groesse_x;
        for (p=0;p<vesa_mouse_zeiger.groesse_y;p++)
        {
                zeiger_auf_pointer=vesa_mouse_zeiger_rettung+p*vesa_mouse_zeiger.groesse_x;
                offset=vesa_mouse_x_old+(long)(vesa_mouse_y_old+p)*vesa_aufloesung_x;
                offset_x=(int)(offset&vesa_and_x);
                if (vesa_fenster_adresse[vesa_schreib_fenster]!=(neue_seg_adresse=(int)(offset>>vesa_granularitaet_potenz)))
                {
                        vesa_fenster_adresse[vesa_schreib_fenster]=neue_seg_adresse;
                        setze_neues_schreib_vesa_fenster();
                }
                for (i=0;i<zeilen_laenge;i++)
                {
                        _CL=zeiger_auf_pointer[i];
                        _AX=vesa_segment_adresse_fenster[vesa_schreib_fenster];
                        _BX=(int) offset_x;
                        asm {
                                push  ax
                                pop   es
                                mov   es:[bx],cl
                        }
                        offset_x++;
                        if (offset_x==vesa_offset_compare)
                        {
                                offset_x=0;
                                vesa_fenster_adresse[vesa_schreib_fenster]++;
                                setze_neues_schreib_vesa_fenster();
                        }
                }
        }
}

/***************************************************************/

void vesa_mouse_schreiben(void)
{
static  int i;
static  int p;
static  int neue_seg_adresse;
static  long offset;
static  BYTE *zeiger_auf_pointer;
static  WORD offset_x;
static  WORD zeilen_laenge;
zeilen_laenge=vesa_mouse_zeiger.groesse_x;
        for (p=0;p<vesa_mouse_zeiger.groesse_y;p++)
        {
                zeiger_auf_pointer=vesa_mouse_zeiger.maus_zeiger+p*vesa_mouse_zeiger.groesse_x;
                offset=vesa_mouse_x+(long)(vesa_mouse_y+p)*vesa_aufloesung_x;
                offset_x=(int)(offset&vesa_and_x);      /* x-koordinate */
                if (vesa_fenster_adresse[vesa_schreib_fenster]!=(neue_seg_adresse=(int)(offset>>vesa_granularitaet_potenz)))
                {
                        vesa_fenster_adresse[vesa_schreib_fenster]=neue_seg_adresse;
                        setze_neues_schreib_vesa_fenster();
                }
                for (i=0;i<zeilen_laenge;i++)
                {
                        if ((_CL=zeiger_auf_pointer[i])!=vesa_mouse_back)
                        {
                                _AX=vesa_segment_adresse_fenster[vesa_schreib_fenster];
                                _BX=(int) offset_x;
                                asm {
                                        push    ax
                                        pop     es
                                        mov     es:[bx],cl
                                }
                        }
                        offset_x++;
                        if (offset_x==vesa_offset_compare)
                        {
                                offset_x=0;
                                vesa_fenster_adresse[vesa_schreib_fenster]++;
                                setze_neues_schreib_vesa_fenster();
                        }
                }
        }
        vesa_mouse_x_old=vesa_mouse_x;
        vesa_mouse_y_old=vesa_mouse_y;
}
#pragma option -k. -N.

/***************************************************************/

int vesa_mouse_init(void)
{
 union REGS regs;
 struct SREGS sregs;
 int x_max=vesa_aufloesung_x-1-vesa_mouse_zeiger.groesse_x;
 int y_max=vesa_aufloesung_y-1-vesa_mouse_zeiger.groesse_y;
 vesa_mouse_deinit();
 if (vesa_mouse_zeiger_rettung)
 {
  free(vesa_mouse_zeiger_rettung);
  vesa_mouse_zeiger_rettung=NULL;
 }
 vesa_mouse_zeiger_rettung=(BYTE *)malloc(vesa_mouse_zeiger.groesse_x*vesa_mouse_zeiger.groesse_y);
 if (vesa_mouse_zeiger_rettung==NULL)
  return vesa_error=KEIN_SPEICHER_DA;
 regs.x.ax=MAUS_RESET;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 if (regs.x.ax!=MAUS_TREIBER_TEST)
  return vesa_error=KEIN_MAUSTREIBER_DA;
 regs.x.dx=FP_OFF(vesa_mouse_update);
 sregs.es=FP_SEG(vesa_mouse_update);
 regs.x.cx=MAUS_EVENT_HANDLER_AKTIV_BITS;
 regs.x.ax=MAUS_EVENT_HANDLER_SETZEN;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 regs.x.ax=MAUS_VERHAELTNIS_MICKEY_PUNKTE;
 regs.x.cx=8;
 regs.x.dx=8;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 regs.x.ax=MAUS_BEWEGE_ZEIGER;
 regs.x.dx=0;
 regs.x.cx=0;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 regs.x.ax=MAUS_HORIZONTALE_BEWEGUNG;
 regs.x.cx=0;
 regs.x.dx=x_max;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 regs.x.ax=MAUS_VERTIKALE_BEWEGUNG;
 regs.x.cx=0;
 regs.x.dx=y_max;
 int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
 vesa_mouse_initialisiert=TRUE;
 vesa_mouse_interrupt=0;
 vesa_mouse_jetzt_schreiben=TRUE;
 vesa_mouse_jetzt_hg_schreiben=FALSE;
 vesa_mouse_jetzt_hg_sichern=TRUE;
 vesa_mouse_force_update();
 return vesa_error=OK;
}

/***************************************************************/

int vesa_mouse_deinit(void)
{
        union REGS regs;
        struct SREGS sregs;
        vesa_mouse_interrupt=-1;
        if (vesa_mouse_zeiger_rettung)
        {
                free(vesa_mouse_zeiger_rettung);
                vesa_mouse_zeiger_rettung=NULL;
        }
        if (vesa_mouse_initialisiert==TRUE)
        {
                vesa_mouse_initialisiert=FALSE;
                regs.x.ax=MAUS_RESET;
                int86x(MAUS_INTERRUPT,&regs,&regs,&sregs);
        }
        else
                return vesa_error=KEINE_MAUS_INSTALLIERT;
        return vesa_error=OK;
}

/***************************************************************/

int vesa_mouse_setze_cursor(int x, int y)
{
        int x_max=vesa_aufloesung_x-1-vesa_mouse_zeiger.groesse_x;
        int y_max=vesa_aufloesung_y-1-vesa_mouse_zeiger.groesse_y;
        if ((x<0)||(x>x_max)||(y<0)||(y>y_max))
                return vesa_error=MAUS_POS_OUT_OF_SCREEN;
        asm{
                mov   ax,MAUS_BEWEGE_ZEIGER
                mov   dx,word ptr y
                mov   cx,word ptr x
                int   MAUS_INTERRUPT
        }
        vesa_mouse_x=x;
        vesa_mouse_y=y;
        vesa_mouse_force_update();
        return vesa_error=OK;
}

/***************************************************************/

void vesa_mouse_verstecke_cursor(void)
{
        vesa_mouse_verstecke++;
        if (vesa_mouse_verstecke==1)
        {
                if (vesa_mouse_initialisiert==TRUE)
                {
                        disable();
                        vesa_mouse_jetzt_hg_schreiben=TRUE;
                        vesa_mouse_jetzt_hg_sichern=FALSE;
                        vesa_mouse_jetzt_schreiben=FALSE;
                        vesa_mouse_force_update();
                        vesa_mouse_interrupt++;
                        vesa_mouse_jetzt_hg_schreiben=FALSE;
                        enable();
                }
        }
}

/***************************************************************/

void vesa_mouse_zeige_cursor(void)
{
        if (vesa_mouse_verstecke>0)
        {
                vesa_mouse_verstecke--;
                if (vesa_mouse_verstecke<=0)
                {
                        if (vesa_mouse_initialisiert==TRUE)
                        {
                                disable();
                                vesa_mouse_jetzt_hg_schreiben=FALSE;
                                vesa_mouse_jetzt_hg_sichern=TRUE;
                                vesa_mouse_jetzt_schreiben=TRUE;
                                vesa_mouse_interrupt--;
                                vesa_mouse_force_update();
                                vesa_mouse_jetzt_hg_schreiben=TRUE;
                                enable();
                        }
                }
        }
}

/***************************************************************/

int vesa_mouse_setze_rect(int x_min, int y_min,int x_max, int y_max)
{
        int x_maxi=vesa_aufloesung_x-1-vesa_mouse_zeiger.groesse_x;
        int y_maxi=vesa_aufloesung_y-1-vesa_mouse_zeiger.groesse_y;
        if ((x_min<0)||(x_max>x_maxi)||(y_min<0)||(y_max>y_maxi))
                return vesa_error=MAUS_POS_OUT_OF_SCREEN;
        asm{
                mov   ax,MAUS_HORIZONTALE_BEWEGUNG
                mov   cx,x_min
                mov   dx,x_max
                int   MAUS_INTERRUPT
                mov   ax,MAUS_VERTIKALE_BEWEGUNG
                mov   cx,y_min
                mov   dx,y_max
                int   MAUS_INTERRUPT
        }
        vesa_mouse_setze_cursor(x_min+(x_max-x_min)/2,y_min+(y_max-y_min)/2 );
        return vesa_error=OK;
}

/***************************************************************/

void vesa_mouse_mickey_pro_8punkte(int mickey_x, int mickey_y)
{
 asm{
 mov   ax,MAUS_VERHAELTNIS_MICKEY_PUNKTE
 mov   cx,mickey_x
 mov   dx,mickey_y
 int   MAUS_INTERRUPT
 }
}

/***************************************************************/


